<div class="controls-container" class:disabled>
    <div id="navigation-controls">
        <button class="btn" on:click={ goPrevious } { disabled }>
            <img src={ arrowBackSvg } alt="icon go to prev page">
        </button>
        <span id="current-page-container">
            <input
                id="current-page-input"
                value={ currentPage }
                on:keypress={ goTo }
                { disabled }
            /> 
            / { numPages || '...' }
        </span>
        <button class="btn" on:click={ goNext } { disabled }>
            <img src={ arrowForwardSvg } alt="icon go to next page">
        </button>
    </div>
    <div div id="zoom-controls">
        <button class="btn" on:click={ zoomIn } { disabled }>
            <img src={ addSvg } alt="icon increase zoom">
        </button>
        <span>{ (zoom * 100).toFixed(0) }%</span>
        <button class="btn" on:click={ zoomOut } { disabled }>
            <img src={ removeSvg } alt="icon decrease zoom">
        </button>
    </div>
</div>

<script>
    import { createEventDispatcher } from 'svelte'
    import {
        arrowBackSvg,
        arrowForwardSvg,
        addSvg,
        removeSvg,
    } from '../medias/icons'
    
    const dispatch = createEventDispatcher()

    export let zoom
    export let currentPage
    export let numPages = 0
    export let disabled

    function goPrevious() {
		if (currentPage == 1) return
        dispatch('pageChange', {
			newPage: currentPage - 1
		})
	}

	function goTo(ev) {
        const desiredPage = Number(ev.target.value)
		if(ev.key == 'Enter' && desiredPage >= 1 && desiredPage <= numPages) {
			dispatch('pageChange', {
                newPage: desiredPage
            })
		}
	}

	function goNext() {
        if (currentPage >= numPages) return
        dispatch('pageChange', {
			newPage: currentPage + 1
		})
	}

	function zoomIn() {
        const newZoom = zoom + 0.1
        if (newZoom > 2) return
        dispatch('zoomChange', { newZoom })
	}

	function zoomOut() {
        const newZoom = zoom - 0.1
        if (newZoom < .4) return
        dispatch('zoomChange', { newZoom })
	}
</script>

<style>
    .controls-container {
        position: absolute;
        left: 50%;
        bottom: 10%;
        transform: translateX(-50%);
        display: flex;
        align-items: center;
        justify-content: center;
        background: rgba(0, 0, 0, .8);
        border-radius: 1.5rem;
        height: 3rem;
        color: white;
        font-size: 1.125rem;
        padding: 0 .6rem;
        width: 22rem;
    }

    .controls-container > * {
        display: flex;
        align-items: center;
    }

    .controls-container > *:not(.controls-container > *:last-child):after {
        content: '';
        display: block;
        width: 1px;
        background: white;
        height: 2rem;
        margin: 0 .6rem;
    }

    .btn {
        cursor: pointer;
        background: transparent;
        border: none;
        outline: none;
        padding: .7rem;
        color: white;
    }

    #current-page-container {
        border-radius: 1.3rem;
    }

    #current-page-input {
        width: 2rem;
        text-align: right;
        border: none;
        outline: none;
        background: transparent;
        color: var(--color-light);
        font-size: 1.125rem;
    }

    img {
        filter: invert(1);
        margin-bottom: -4px;
    }

    .disabled {
        opacity: .5;
        cursor: default;
    }
</style>